      subroutine newboost(p,mass,px,py,pz)

      implicit none
      real p, mass, px, py, pz

      real vec(4)
      real gama(2), bega(2), cfi(2), sfi(2)
      logical start 
      data start /.true./
      save start, bega, gama, cfi, sfi
     
      if(start) then
         start=.false.
         call get_boost1(gama(1),bega(1),cfi(1),sfi(1))
         call get_boost2(gama(2),bega(2),cfi(2),sfi(2))
c         print*,'gamma: ',gama
c         print*,'betag: ',bega
c         print*,'theta: ',atan2(sfi(1),cfi(1)),atan2(sfi(2),cfi(2))
      endif

      vec(1)=px
      vec(2)=py
      vec(3)=pz
      vec(4)=sqrt(p**2+mass**2)

      call lorent(vec,gama(1),bega(1),cfi(1),sfi(1))
      call ilorent(vec,gama(2),bega(2),cfi(2),sfi(2))
      px=vec(1)
      py=vec(2)
      pz=vec(3)
      p=sqrt(px**2+py**2+pz**2)
  
      end


      subroutine lorent(cetv,gama,bega,cfi,sfi)

      implicit none
      real cetv(4), gama, bega, cfi, sfi
      real vec(4)

      vec(1)=cetv(1)*cfi-cetv(3)*sfi
      vec(2)=cetv(2)
      vec(3)=cetv(1)*sfi+cetv(3)*cfi
      vec(4)=cetv(4)

      cetv(1)=vec(1)
      cetv(2)=vec(2)
      cetv(3)=gama*vec(3)-bega*vec(4)
      cetv(4)=gama*vec(4)-bega*vec(3)

      end


      subroutine ilorent(cetv,gama,bega,cfi,sfi)

      implicit none
      real cetv(4), gama, bega, cfi, sfi
      real vec(4)

      vec(1)=cetv(1)
      vec(2)=cetv(2)
      vec(3)=gama*cetv(3)+bega*cetv(4)
      vec(4)=gama*cetv(4)+bega*cetv(3)

      cetv(1)=vec(1)*cfi+vec(3)*sfi
      cetv(2)=vec(2)
      cetv(3)=-vec(1)*sfi+vec(3)*cfi
      cetv(4)=vec(4)

      end


      subroutine get_boost1(gama,bega,cfi,sfi)

      implicit none
      real gama, bega, cfi, sfi

      real fi, ama
      real vb(4), theta, eher, eler
      data theta /22.e-3/, eher /7.996/, eler /3.5/
      
      
      vb(1)=eher*sin(theta)
      vb(2)=0.
      vb(3)=eher*cos(theta)-eler
      vb(4)=eher+eler
      fi=atan2(vb(1),vb(3))
      cfi=cos(fi)
      sfi=sin(fi)

      ama=sqrt(vb(4)**2-(vb(1)**2+vb(2)**2+vb(3)**2))
      gama=vb(4)/ama
      bega=sqrt(vb(1)**2+vb(2)**2+vb(3)**2)/ama

      return
      end


      subroutine get_boost2(gama,bega,cfi,sfi)

      implicit none
      real gama, bega, cfi, sfi

      real fi, ama
      real vb(4), theta, eher, eler
      data theta /83.e-3/, eher /7.0/, eler /4.0/
      
      
      vb(1)=(eher+eler)*sin(theta/2)
      vb(2)=0.
      vb(3)=(eher-eler)*cos(theta/2)
      vb(4)=eher+eler
      fi=atan2(vb(1),vb(3))
      cfi=cos(fi)
      sfi=sin(fi)

      ama=sqrt(vb(4)**2-(vb(1)**2+vb(2)**2+vb(3)**2))
      gama=vb(4)/ama
      bega=sqrt(vb(1)**2+vb(2)**2+vb(3)**2)/ama

      return
      end

